#include <bits/stdc++.h>
using namespace std;
map <int, int> br;
map<int, pair<int,int> > c;
int m[2005][2005];
int main(){
    int n, k;
    int x;
    scanf("%d%d", &n, &k);
    for(int i=0; i<n; ++i){
        for(int j=0; j<n; ++j){
            scanf("%d", &x);
            m[i][j]=x;
            br[x]++;
            if(br[x]==1) c[x]=make_pair(i, j);
        }
    }
    int sol=0;
    for(int l=1; l<=k; ++l){
        if(br[l]==0)continue;
        int i=c[l].first, j=c[l].second;
        int a=0, b=0;
        while(m[i+a][j]==l)a++;
        while(m[i][j+b]==l) b++;
        if(a*b!=br[l]) continue;
        bool t=true;
        for(int ii=1;t&& ii<a; ++ii){
            for(int jj=1;t&& jj<b;++jj){
                if(m[i+ii][j+jj]!=l)t=false;
            }
        }
        if(t) sol++;
    }
    printf("%d", sol);
    return 0;
}